<template>
  <div>
    <!-- Views -->
    <div class="flex flex-col items-stretch justify-start pt-4 mr-4">
      <sidebar-entry :active="isView('Focus')" @click="openView({ name: 'Focus' })" color="gray">
        <template #icon><i class="hero fire solid mr-4 text-black"></i></template>
        Focus
      </sidebar-entry>
      <sidebar-entry :active="isView('Upcoming')" @click="openView({ name: 'Upcoming' })" color="orange">
        <template #icon><i class="hero calendar solid mr-4"></i></template>
        Upcoming
      </sidebar-entry>
      <sidebar-entry :active="isView('Done')" @click="openView({ name: 'Done' })" color="green">
        <template #icon><i class="hero check-circle solid mr-4"></i></template>
        Done
      </sidebar-entry>
    </div>

    <div class="mt-8 mr-4">
      <sidebar-entry :active="isView('Inbox')" @click="openView({ name: 'Inbox' })" color="white">
        <template #icon><i class="hero inbox solid mr-4"></i></template>
        Inbox
      </sidebar-entry>
    </div>

    <!-- Workspaces -->
    <div class="mt-4 sidebar">
      <div class="text-gray-500 font-bold tracking-wide text-xs uppercase ml-12 mb-2">
        Workspaces
      </div>
      <div class="flex flex-col items-stretch justify-start mr-4">
        <sidebar-entry
          v-for="workspace of workspaces"
          :key="workspace.id"
          @click="openView({ name: 'Tasks', params: { workspace: workspace.id } })"
          :active="isActiveWorkspace(workspace)"
          class="workspace"
          :color="workspace.color"
        >
          <template #icon>
            <workspaces-icon :workspace="workspace" class="mr-4" />
          </template>
          <template #default>
            <div class="grid flex-1" style="grid-template-columns: 1fr auto">
              <div class="text-black truncate">
                {{ workspace.name }}
              </div>
              <div v-if="edit" class="actions flex flex-row items-center">
                <i
                  @click.stop="modals.show(`workspace-${workspace.id}`)"
                  class="hero pencil outline text-gray-500 p-2 -my-2 rounded-full clickable-bg"
                ></i>
              </div>
              <modal :is="modals.inlined(`workspace-${workspace.id}`)" v-slot:default="{ modal }" dimmed>
                <workspaces-detail :workspace="workspace" focus class="max-w-md p-4" @deleted="modal.hide()" />
              </modal>
            </div>
          </template>
        </sidebar-entry>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Workspace from "@/models/Workspace";
import { inlined, useModals } from "@/use/modal";
import { computed, onRenderTriggered, watch } from "vue";
import router from "@/router";
import { openView } from "@/use/navigation";
import SidebarEntry from "./SidebarEntry.vue";
import WorkspacesIcon from "@/components/Workspaces/Icon.vue";
import WorkspacesDetail from "@/components/Workspaces/Detail.vue";

export default {
  components: { SidebarEntry, WorkspacesIcon, WorkspacesDetail },
  props: {
    edit: {
      type: Boolean,
      default: false
    }
  },
  setup() {
    const modals = useModals({ WorkspacesCreator: inlined() });

    return {
      isView: (name: string) => router.currentRoute.value.name == name,
      openView,
      modals,
      workspaces: computed(() => Workspace.query().getSync()),
      isActiveWorkspace: (checkWorkspace: Workspace) =>
        router.currentRoute.value.name == "Tasks" && router.currentRoute.value.params.workspace == checkWorkspace.id
    };
  }
};
</script>

<style lang="stylus" scoped>
.workspace:not(:hover)
  .actions
    @apply hidden
</style>
